فهرست منبع

Add some nice to haves to #i3

Colin Powell 6 سال پیش
والد
کامیت
9fad0fcb45

+ 15 - 0
i3/.config/i3/bright.sh

@@ -0,0 +1,15 @@
+#!/usr/bin/env bash
+
+if [[ $1 == -d ]]; then
+    current=$(xrandr --verbose | grep -m 1 -i brightness | awk -F' ' '{ print $2 }')
+    new=$(echo "$current - 0.1" | bc -l)
+    xrandr --output eDP-1 --brightness 0$new
+elif [[ $1 == -u ]]; then
+    current=$(xrandr --verbose | grep -m 1 -i brightness | awk -F' ' '{ print $2 }')
+new=$(echo "$current + 0.1" | bc -l)
+    xrandr --output eDP-1 --brightness 0$new
+elif [[ $1 == -m ]]; then
+    xrandr --output eDP-1 --brightness 1
+else
+    xrandr --output eDP-1 --brightness $1
+fi

+ 50 - 0
i3/.config/i3/config

@@ -50,6 +50,7 @@ bindsym $mod+Shift+q kill
 
 # start dmenu (a program launcher)
 bindsym $mod+d exec --no-startup-id rofi -show combi
+bindsym XF86LaunchA exec --no-startup-id rofi -show combi
 # There also is the (new) i3-dmenu-desktop which only displays applications
 # shipping a .desktop file. It is a wrapper around dmenu, so you need that
 # installed.
@@ -197,3 +198,52 @@ for_window [class="^.*"] border pixel 3
 assign [class="discord"] $ws3
 
 exec --no-startup-id xrdb ~/.Xresources
+
+## Volume control
+# Path to volume control, without trailing slash
+set $volumepath ~/.config/i3/i3-volume
+
+# Command for the status line (used with -t, requires -u)
+#   ie: i3blocks, i3status
+set $statuscmd i3status
+
+# Signal used to update the status line (used with -u, requires -t)
+#   i3blocks uses SIGRTMIN+10 by default
+#   i3status uses SIGUSR1 by default
+set $statussig SIGUSR1
+
+# Amount to increase/decrease volume as a percentage (used with -i, -d)
+set $volumestep 10
+
+# alsa-utils settings when not using pulseaudio-utils
+#
+# To configure a default card, see https://www.alsa-project.org/main/index.php/Asoundrc
+#
+# Card number to control. (used with -a and -c)
+#   If not specified, i3-volume will let `amixer` use a default.
+#   List cards: aplay -l
+#set $alsacard 1
+
+# Uncomment to use alsa-utils (append "-c $alsacard" without quotes to override default card)
+#bindsym XF86AudioRaiseVolume exec $volumepath/volume -anp -i $volumestep -t $statuscmd -u $statussig
+#bindsym XF86AudioLowerVolume exec $volumepath/volume -anp -d $volumestep -t $statuscmd -u $statussig
+#bindsym XF86AudioMute        exec $volumepath/volume -amn -t $statuscmd -u $statussig
+
+# pulseaudio-utils settings when not using alsa-utils
+#
+# Symbolic name for sink (numeric index not supported) (used with -s $sinkname)
+#   Recommended: comment out this setting and omit the -s option to use default sink
+#   List sink names: pacmd list-sinks | awk -F "[<>]" '/^\s+name: <.*>/{print $2}'
+#set $sinkname alsa_output.pci-0000_00_1b.0.analog-stereo
+
+# Using pulseaudio-utils (append "-s $sinkname" without quotes to override default sink)
+bindsym XF86AudioRaiseVolume exec $volumepath/volume -np -i $volumestep -t $statuscmd -u $statussig
+bindsym XF86AudioLowerVolume exec $volumepath/volume -np -d $volumestep -t $statuscmd -u $statussig
+bindsym XF86AudioMute        exec $volumepath/volume -mn -t $statuscmd -u $statussig
+
+# Sreen brightness controls
+bindsym XF86MonBrightnessUp exec ~/.config/i3/bright.sh -u # increase screen brightness
+bindsym XF86MonBrightnessDown exec ~/.config/i3/bright.sh -d # decrease screen brightness
+bindsym XF86Search exec ~/.config/i3/bright.sh 1 # decrease screen brightness
+
+bindsym XF86Explorer exec arandr

+ 339 - 0
i3/.config/i3/i3-volume/LICENSE

@@ -0,0 +1,339 @@
+                    GNU GENERAL PUBLIC LICENSE
+                       Version 2, June 1991
+
+ Copyright (C) 1989, 1991 Free Software Foundation, Inc., <http://fsf.org/>
+ 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+                            Preamble
+
+  The licenses for most software are designed to take away your
+freedom to share and change it.  By contrast, the GNU General Public
+License is intended to guarantee your freedom to share and change free
+software--to make sure the software is free for all its users.  This
+General Public License applies to most of the Free Software
+Foundation's software and to any other program whose authors commit to
+using it.  (Some other Free Software Foundation software is covered by
+the GNU Lesser General Public License instead.)  You can apply it to
+your programs, too.
+
+  When we speak of free software, we are referring to freedom, not
+price.  Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+this service if you wish), that you receive source code or can get it
+if you want it, that you can change the software or use pieces of it
+in new free programs; and that you know you can do these things.
+
+  To protect your rights, we need to make restrictions that forbid
+anyone to deny you these rights or to ask you to surrender the rights.
+These restrictions translate to certain responsibilities for you if you
+distribute copies of the software, or if you modify it.
+
+  For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must give the recipients all the rights that
+you have.  You must make sure that they, too, receive or can get the
+source code.  And you must show them these terms so they know their
+rights.
+
+  We protect your rights with two steps: (1) copyright the software, and
+(2) offer you this license which gives you legal permission to copy,
+distribute and/or modify the software.
+
+  Also, for each author's protection and ours, we want to make certain
+that everyone understands that there is no warranty for this free
+software.  If the software is modified by someone else and passed on, we
+want its recipients to know that what they have is not the original, so
+that any problems introduced by others will not reflect on the original
+authors' reputations.
+
+  Finally, any free program is threatened constantly by software
+patents.  We wish to avoid the danger that redistributors of a free
+program will individually obtain patent licenses, in effect making the
+program proprietary.  To prevent this, we have made it clear that any
+patent must be licensed for everyone's free use or not licensed at all.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.
+
+                    GNU GENERAL PUBLIC LICENSE
+   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+  0. This License applies to any program or other work which contains
+a notice placed by the copyright holder saying it may be distributed
+under the terms of this General Public License.  The "Program", below,
+refers to any such program or work, and a "work based on the Program"
+means either the Program or any derivative work under copyright law:
+that is to say, a work containing the Program or a portion of it,
+either verbatim or with modifications and/or translated into another
+language.  (Hereinafter, translation is included without limitation in
+the term "modification".)  Each licensee is addressed as "you".
+
+Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope.  The act of
+running the Program is not restricted, and the output from the Program
+is covered only if its contents constitute a work based on the
+Program (independent of having been made by running the Program).
+Whether that is true depends on what the Program does.
+
+  1. You may copy and distribute verbatim copies of the Program's
+source code as you receive it, in any medium, provided that you
+conspicuously and appropriately publish on each copy an appropriate
+copyright notice and disclaimer of warranty; keep intact all the
+notices that refer to this License and to the absence of any warranty;
+and give any other recipients of the Program a copy of this License
+along with the Program.
+
+You may charge a fee for the physical act of transferring a copy, and
+you may at your option offer warranty protection in exchange for a fee.
+
+  2. You may modify your copy or copies of the Program or any portion
+of it, thus forming a work based on the Program, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+    a) You must cause the modified files to carry prominent notices
+    stating that you changed the files and the date of any change.
+
+    b) You must cause any work that you distribute or publish, that in
+    whole or in part contains or is derived from the Program or any
+    part thereof, to be licensed as a whole at no charge to all third
+    parties under the terms of this License.
+
+    c) If the modified program normally reads commands interactively
+    when run, you must cause it, when started running for such
+    interactive use in the most ordinary way, to print or display an
+    announcement including an appropriate copyright notice and a
+    notice that there is no warranty (or else, saying that you provide
+    a warranty) and that users may redistribute the program under
+    these conditions, and telling the user how to view a copy of this
+    License.  (Exception: if the Program itself is interactive but
+    does not normally print such an announcement, your work based on
+    the Program is not required to print an announcement.)
+
+These requirements apply to the modified work as a whole.  If
+identifiable sections of that work are not derived from the Program,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works.  But when you
+distribute the same sections as part of a whole which is a work based
+on the Program, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Program.
+
+In addition, mere aggregation of another work not based on the Program
+with the Program (or with a work based on the Program) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+  3. You may copy and distribute the Program (or a work based on it,
+under Section 2) in object code or executable form under the terms of
+Sections 1 and 2 above provided that you also do one of the following:
+
+    a) Accompany it with the complete corresponding machine-readable
+    source code, which must be distributed under the terms of Sections
+    1 and 2 above on a medium customarily used for software interchange; or,
+
+    b) Accompany it with a written offer, valid for at least three
+    years, to give any third party, for a charge no more than your
+    cost of physically performing source distribution, a complete
+    machine-readable copy of the corresponding source code, to be
+    distributed under the terms of Sections 1 and 2 above on a medium
+    customarily used for software interchange; or,
+
+    c) Accompany it with the information you received as to the offer
+    to distribute corresponding source code.  (This alternative is
+    allowed only for noncommercial distribution and only if you
+    received the program in object code or executable form with such
+    an offer, in accord with Subsection b above.)
+
+The source code for a work means the preferred form of the work for
+making modifications to it.  For an executable work, complete source
+code means all the source code for all modules it contains, plus any
+associated interface definition files, plus the scripts used to
+control compilation and installation of the executable.  However, as a
+special exception, the source code distributed need not include
+anything that is normally distributed (in either source or binary
+form) with the major components (compiler, kernel, and so on) of the
+operating system on which the executable runs, unless that component
+itself accompanies the executable.
+
+If distribution of executable or object code is made by offering
+access to copy from a designated place, then offering equivalent
+access to copy the source code from the same place counts as
+distribution of the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+  4. You may not copy, modify, sublicense, or distribute the Program
+except as expressly provided under this License.  Any attempt
+otherwise to copy, modify, sublicense or distribute the Program is
+void, and will automatically terminate your rights under this License.
+However, parties who have received copies, or rights, from you under
+this License will not have their licenses terminated so long as such
+parties remain in full compliance.
+
+  5. You are not required to accept this License, since you have not
+signed it.  However, nothing else grants you permission to modify or
+distribute the Program or its derivative works.  These actions are
+prohibited by law if you do not accept this License.  Therefore, by
+modifying or distributing the Program (or any work based on the
+Program), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Program or works based on it.
+
+  6. Each time you redistribute the Program (or any work based on the
+Program), the recipient automatically receives a license from the
+original licensor to copy, distribute or modify the Program subject to
+these terms and conditions.  You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+
+  7. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Program at all.  For example, if a patent
+license would not permit royalty-free redistribution of the Program by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Program.
+
+If any portion of this section is held invalid or unenforceable under
+any particular circumstance, the balance of the section is intended to
+apply and the section as a whole is intended to apply in other
+circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system, which is
+implemented by public license practices.  Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+  8. If the distribution and/or use of the Program is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Program under this License
+may add an explicit geographical distribution limitation excluding
+those countries, so that distribution is permitted only in or among
+countries not thus excluded.  In such case, this License incorporates
+the limitation as if written in the body of this License.
+
+  9. The Free Software Foundation may publish revised and/or new versions
+of the General Public License from time to time.  Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+Each version is given a distinguishing version number.  If the Program
+specifies a version number of this License which applies to it and "any
+later version", you have the option of following the terms and conditions
+either of that version or of any later version published by the Free
+Software Foundation.  If the Program does not specify a version number of
+this License, you may choose any version ever published by the Free Software
+Foundation.
+
+  10. If you wish to incorporate parts of the Program into other free
+programs whose distribution conditions are different, write to the author
+to ask for permission.  For software which is copyrighted by the Free
+Software Foundation, write to the Free Software Foundation; we sometimes
+make exceptions for this.  Our decision will be guided by the two goals
+of preserving the free status of all derivatives of our free software and
+of promoting the sharing and reuse of software generally.
+
+                            NO WARRANTY
+
+  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
+FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
+OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
+PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
+OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
+TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
+PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
+REPAIR OR CORRECTION.
+
+  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
+REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
+INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
+OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
+TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
+YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
+PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
+POSSIBILITY OF SUCH DAMAGES.
+
+                     END OF TERMS AND CONDITIONS
+
+            How to Apply These Terms to Your New Programs
+
+  If you develop a new program, and you want it to be of the greatest
+possible use to the public, the best way to achieve this is to make it
+free software which everyone can redistribute and change under these terms.
+
+  To do so, attach the following notices to the program.  It is safest
+to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least
+the "copyright" line and a pointer to where the full notice is found.
+
+    {description}
+    Copyright (C) {year}  {fullname}
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License along
+    with this program; if not, write to the Free Software Foundation, Inc.,
+    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+Also add information on how to contact you by electronic and paper mail.
+
+If the program is interactive, make it output a short notice like this
+when it starts in an interactive mode:
+
+    Gnomovision version 69, Copyright (C) year name of author
+    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+    This is free software, and you are welcome to redistribute it
+    under certain conditions; type `show c' for details.
+
+The hypothetical commands `show w' and `show c' should show the appropriate
+parts of the General Public License.  Of course, the commands you use may
+be called something other than `show w' and `show c'; they could even be
+mouse-clicks or menu items--whatever suits your program.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the program, if
+necessary.  Here is a sample; alter the names:
+
+  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
+  `Gnomovision' (which makes passes at compilers) written by James Hacker.
+
+  {signature of Ty Coon}, 1 April 1989
+  Ty Coon, President of Vice
+
+This General Public License does not permit incorporating your program into
+proprietary programs.  If your program is a subroutine library, you may
+consider it more useful to permit linking proprietary applications with the
+library.  If this is what you want to do, use the GNU Lesser General
+Public License instead of this License.

+ 105 - 0
i3/.config/i3/i3-volume/README.md

@@ -0,0 +1,105 @@
+i3-volume
+=========
+[![License: GPL v2](https://img.shields.io/badge/License-GPL%20v2-blue.svg)][license]
+
+Volume control and volume notifications for [i3wm]
+
+## Installation
+
+#### Requirements
+* [i3wm] - A better tiling and dynamic window manager
+* [alsa-utils] (if not using [pulseaudio-utils]) - Advanced Linux Sound Architecture utils
+* [pulseaudio-utils] (if not using [alsa-utils]) - Sound system for POSIX OSes
+
+#### Optional
+* A [libnotify] compatible notification daemon such as [notify-osd] or [dunst]
+* `notify-send` (provided by [libnotify]) or `dunstify` (provided by [dunst])
+
+#### ALSA mixer and PulseAudio
+Volume control can be done through either [alsa-utils], [pulseaudio-utils], or both. The example configuration uses [pulseaudio-utils]. If you want to use [alsa-utils] instead, comment out the `bindsyms` under [pulseaudio-utils] and uncomment the `bindsyms` under [alsa-utils].
+
+#### Notifications
+Notifications are provided by [libnotify]. Any [libnotify] compatible notification daemon can be used for notifications. The most common are [notify-osd] and [dunst]. To disable notifications remove the `-n` option from the `bindsyms` in the example configuration below.
+
+If you are using [dunst], you may optionally choose to use `dunstify` instead of `notify-send` by adding the `-y` option to the `bindsyms` in the example configuration below.
+
+Expiration time of notifications can be changed using the `-e <time_in_milliseconds>` option. Default is 1500 ms.
+
+### Guide
+Clone this repository: `git clone https://github.com/hastinbe/i3-volume.git ~/i3-volume`
+
+Edit the following example and append it to your ~/.config/i3/config:
+
+```
+## Volume control
+
+# Path to volume control, without trailing slash
+set $volumepath ~/i3-volume
+
+# Command for the status line (used with -t, requires -u)
+#   ie: i3blocks, i3status
+set $statuscmd i3status
+
+# Signal used to update the status line (used with -u, requires -t)
+#   i3blocks uses SIGRTMIN+10 by default
+#   i3status uses SIGUSR1 by default
+set $statussig SIGUSR1
+
+# Amount to increase/decrease volume as a percentage (used with -i, -d)
+set $volumestep 5
+
+# alsa-utils settings when not using pulseaudio-utils
+#
+# To configure a default card, see https://www.alsa-project.org/main/index.php/Asoundrc
+#
+# Card number to control. (used with -a and -c)
+#   If not specified, i3-volume will let `amixer` use a default.
+#   List cards: aplay -l
+#set $alsacard 1
+
+# Uncomment to use alsa-utils (append "-c $alsacard" without quotes to override default card)
+#bindsym XF86AudioRaiseVolume exec $volumepath/volume -anp -i $volumestep -t $statuscmd -u $statussig
+#bindsym XF86AudioLowerVolume exec $volumepath/volume -anp -d $volumestep -t $statuscmd -u $statussig
+#bindsym XF86AudioMute        exec $volumepath/volume -amn -t $statuscmd -u $statussig
+
+# pulseaudio-utils settings when not using alsa-utils
+#
+# Symbolic name for sink (numeric index not supported) (used with -s $sinkname)
+#   Recommended: comment out this setting and omit the -s option to use default sink
+#   List sink names: pacmd list-sinks | awk -F "[<>]" '/^\s+name: <.*>/{print $2}'
+#set $sinkname alsa_output.pci-0000_00_1b.0.analog-stereo
+
+# Using pulseaudio-utils (append "-s $sinkname" without quotes to override default sink)
+bindsym XF86AudioRaiseVolume exec $volumepath/volume -np -i $volumestep -t $statuscmd -u $statussig
+bindsym XF86AudioLowerVolume exec $volumepath/volume -np -d $volumestep -t $statuscmd -u $statussig
+bindsym XF86AudioMute        exec $volumepath/volume -mn -t $statuscmd -u $statussig
+```
+Reload i3 configuration by pressing `mod+Shift+r`
+
+## Usage
+Use your keyboard volume keys to increase, decrease, or mute your volume. If you have a volume indicator in your status line it will be updated to reflect the volume change (requires `-t $statuscmd` and `-u $statussig` to be set). When notifications are enabled (`-n` flag) a popup will display the volume level.
+
+Example of notifications using [notify-osd]:
+
+![Volume Notifications](https://github.com/hastinbe/i3-volume/blob/master/volume-notifications.png)
+
+## Common Issues
+* [alsa-utils] won't unmute if `pulseaudio` is running. You must disable pulseaudio's auto respawn and terminate the `pulseaudio` process. Or use [pulseaudio-utils] for unmuting.
+* [dunst] isn't displaying icons in notifications. `icon_position` needs to be set to either `left` or `right` (default is `off`) in your `~/.config/dunst/dunstrc`.
+* [dunst] icons are too small. Change `icon_path` in your `~/.config/dunst/dunstrc` to a path containing larger icons, such as `/usr/share/icons/gnome/32x32/status/:/usr/share/icons/gnome/32x32/devices/`. Alternatively try increasing `max_icon_size`
+
+`Note` only one notification daemon can be running at the same time. [dunst] can't be running for notifications to go through [notify-osd] and vice-versa.
+
+## License
+
+`i3-volume` is released under [GNU General Public License v2][license]
+
+Copyright (C) 1989, 1991 Free Software Foundation, Inc.
+
+[alsa-utils]: https://alsa.opensrc.org/Alsa-utils
+[dunst]: https://dunst-project.org
+[i3wm]: https://i3wm.org
+[libnotify]: https://developer.gnome.org/libnotify
+[license]: https://www.gnu.org/licenses/gpl-2.0.en.html
+[notify-osd]: https://launchpad.net/notify-osd
+[pulseaudio-utils]: https://www.freedesktop.org/wiki/Software/PulseAudio/

+ 463 - 0
i3/.config/i3/i3-volume/volume

@@ -0,0 +1,463 @@
+#!/bin/bash
+#
+#  i3-volume
+#
+#  Volume control and volume notifications for i3wm.
+#
+#  Requires:
+#    alsa-utils or pulseaudio-utils
+#    awk (POSIX compatible)
+#
+#  Optional:
+#    A libnotify compatible notification daemon such as notify-osd or dunst
+#    notify-send (libnotify) or dunstify (dunst)
+#
+#  Copyright (c) 2016 Beau Hastings. All rights reserved.
+#  License: GNU General Public License v2
+#
+#  Author: Beau Hastings <beausy@gmail.com>
+#  URL: https://github.com/hastinbe/i3-volume
+
+# Get default sink name
+get_default_sink_name() {
+    pacmd stat | awk -F": " '/^Default sink name: /{print $2}'
+}
+
+# Get the volume as a percentage.
+get_volume() {
+    if $opt_use_amixer; then
+        get_volume_amixer $card
+    else
+        get_volume_pulseaudio $sink
+    fi
+}
+
+# Get the volume as a percentage.
+#
+# Arguments
+#   Sink name   (string) Symbolic name of sink.
+get_volume_pulseaudio() {
+    local sink="$1"
+
+    pacmd list-sinks |
+        awk -W posix '/^[ \t]+name: /{insink = $2 == "<'$sink'>"}
+                      /^[ \t]+volume: / && insink {gsub("%", ""); print $5; exit}'
+}
+
+# Get the volume as a percentage.
+#
+# Arguments
+#   Card        (integer) Card number to control.
+get_volume_amixer() {
+    local card="$1"
+    local volume
+
+    if [ -n "$card" ]; then
+        volume=$(amixer -c "$card" -- sget Master)
+    else
+        volume=$(amixer sget Master)
+    fi
+
+    echo $volume | awk -W posix -F'[][]' '/dB/ { gsub("%", ""); print $2 }'
+}
+
+# Increase volume relative to current volume.
+#
+# Arguments:
+#   Step        (integer) Percentage to increase by.
+raise_volume() {
+    if $opt_use_amixer; then
+        raise_volume_amixer "$card" "$1"
+    else
+        raise_volume_pulseaudio "$sink" "$1"
+    fi
+}
+
+# Increase volume relative to current volume using pulseaudio.
+#
+# Arguments:
+#   Sink name   (string)  Symbolic name of sink.
+#   Step        (integer) Percentage to increase by.
+raise_volume_pulseaudio() {
+    local sink="$1"
+    local step="${2:-5}"
+
+    set_volume_pulseaudio "$sink" "+${step}%"
+}
+
+# Increase volume relative to current volume using amixer.
+#
+# Arguments:
+#   Card        (integer) Card number to control.
+#   Step        (integer) Percentage to increase by.
+raise_volume_amixer() {
+    local card="$1"
+    local step="${2:-5}"
+
+    set_volume_amixer "$card" "${step}%+"
+}
+
+# Decrease volume relative to current volume.
+#
+# Arguments:
+#   Step        (integer) Percentage to decrease by.
+lower_volume() {
+    if $opt_use_amixer; then
+        lower_volume_amixer "$card" "$1"
+    else
+        lower_volume_pulseaudio "$sink" "$1"
+    fi
+}
+
+# Decrease volume relative to current volume using pulseaudio.
+#
+# Arguments:
+#   Sink name   (string)  Symbolic name of sink.
+#   Step        (integer) Percentage to decrease by.
+lower_volume_pulseaudio() {
+    local sink="$1"
+    local step="${2:-5}"
+
+    set_volume_pulseaudio "$sink" "-${step}%"
+}
+
+# Decrease volume relative to current volume using amixer.
+#
+# Arguments:
+#   Card        (integer) Card number to control.
+#   Step        (integer) Percentage to decrease by.
+lower_volume_amixer() {
+    local card="$1"
+    local step="${2:-5}"
+
+    set_volume_amixer "$card" "${step}%-"
+}
+
+# Set volume.
+#
+# Arguments:
+#   Step        (integer) Percentage to decrease by.
+set_volume() {
+    if $opt_use_amixer; then
+        set_volume_amixer "$card" "$1"
+    else
+        set_volume_pulseaudio "$sink" "$1"
+    fi
+}
+
+# Set volume using pulseaudio.
+#
+# Arguments:
+#   Sink name   (string) Symbolic name of sink.
+#   Volume      (integer|linear factor|percentage|decibel)
+set_volume_pulseaudio() {
+    local sink="$1"
+    local vol="$2"
+
+    pactl set-sink-volume "$sink" "$vol" || pactl set-sink-volume "$sink" -- "$vol"
+}
+
+# Set volume using amixer.
+#
+# Arguments:
+#   Card        (integer) Card number to control.
+#   Volume      (integer|linear factor|percentage|decibel)
+set_volume_amixer() {
+    local card="$1"
+    local vol="$2"
+
+    if [ -n "$card" ]; then
+        amixer -q -c "$card" -- set Master "$vol"
+    else
+        amixer -q set Master "$vol"
+    fi
+}
+
+# Toggle mute.
+toggle_mute() {
+    if $opt_use_amixer; then
+        toggle_mute_amixer "$card"
+    else
+        toggle_mute_pulseaudio "$sink"
+    fi
+}
+
+# Toggle mute using pulseaudio.
+#
+# Arguments:
+#   Sink name   (string) Symbolic name of sink.
+toggle_mute_pulseaudio() {
+    local sink="$1"
+
+    pactl set-sink-mute "$sink" toggle
+}
+
+# Toggle mute using amixer.
+#
+# Arguments:
+#   Card        (integer) Card number to control.
+toggle_mute_amixer() {
+    local card="$1"
+
+    if [ -n "$card" ]; then
+        amixer -q -c "$card" -- set Master toggle
+    else
+        amixer -q set Master toggle
+    fi
+}
+
+# Check if muted.
+is_muted() {
+    if $opt_use_amixer; then
+        return $(is_muted_amixer "$card")
+    else
+        return $(is_muted_pulseaudio "$sink")
+    fi
+}
+
+# Check if sink is muted.
+#
+# Arguments:
+#   Sink name    (string) Symbolic name of sink.
+#
+# Returns:
+#   0 when true, 1 when false.
+is_muted_pulseaudio() {
+    local sink="$1"
+
+    muted=$(pacmd list-sinks |
+                   awk -W posix '/^[ \t]+name: /{insink = $2 == "<'$sink'>"}
+                                 /^[ \t]+muted: / && insink {print $2; exit}')
+    [ "$muted" = "yes" ]
+}
+
+# Check if card is muted.
+#
+# Arguments:
+#   Card        (integer) Card number to control.
+#
+# Returns:
+#   0 when true, 1 when false.
+is_muted_amixer() {
+    local card="$1"
+    local output
+
+    if [ -n "$card" ]; then
+        output=$(amixer -c "$card" -- sget Master)
+    else
+        output=$(amixer sget Master)
+    fi
+
+    status=$(echo $output | awk -W posix -F'[][]' '/dB/ { print $6 }')
+
+    [ "$status" = "off" ]
+}
+
+# Gets an icon for the provided volume.
+#
+# Arguments:
+#   Volume      (integer) An integer indicating the volume.
+#
+# Returns:
+#   The volume icon name.
+get_volume_icon() {
+    local vol="$1"
+    local icon
+
+    if [ "$vol" -ge 70 ]; then icon="audio-volume-high"
+    elif [ "$vol" -ge 40 ]; then icon="audio-volume-medium"
+    elif [ "$vol" -gt 0 ]; then icon="audio-volume-low"
+    else icon="audio-volume-low"
+    fi
+
+    echo "${icon}"
+}
+
+# Display a notification indicating the volume is muted.
+notify_muted() {
+    if $opt_use_dunstify; then
+        dunstify -i audio-volume-muted -t $expires -h int:value:0 -h string:synchronous:volume "Volume muted" -r 1000
+    else
+        notify-send -i audio-volume-muted -t $expires -h int:value:0 -h string:synchronous:volume "Volume muted"
+    fi
+}
+
+# Display a notification indicating the current volume.
+notify_volume() {
+    local vol=$(get_volume)
+    local icon=$(get_volume_icon "$vol")
+    local text="Volume ${vol}%"
+
+    if $opt_show_volume_progress; then
+        local progress=$(get_progress_bar "$vol")
+        text="$text $progress"
+    fi
+
+    if $opt_use_dunstify; then
+        dunstify -i "$icon" -t $expires -h int:value:"$vol" -h string:synchronous:volume "$text" -r 1000
+    else
+        notify-send -i "$icon" -t $expires -h int:value:"$vol" -h string:synchronous:volume "$text"
+    fi
+}
+
+# Updates the status line.
+#
+# Arguments:
+#   signal  (string) The signal used to update the status line.
+#   proc    (string) The name of the status line process.
+update_statusline() {
+    local signal="$1"
+    local proc="$2"
+    pkill "-$signal" "$proc"
+}
+
+# Generates a progress bar for the provided value.
+#
+# Arguments:
+#   Percentage      (integer) Percentage of progress.
+#   Maximum         (integer) Maximum percentage. (default: 100)
+#   Divisor         (integer) For calculating the ratio of blocks to progress (default: 5)
+#
+# Returns:
+#   The progress bar.
+get_progress_bar() {
+    local percent="$1"
+    local max_percent=${2:-100}
+    local divisor=${3:-5}
+    local progress=$((($percent > $max_percent ? $max_percent : $percent) / $divisor))
+
+    printf '█%.0s' $(eval echo "{1..$progress}")
+}
+
+# Display program usage.
+usage() {
+    echo "Usage: $0 [options]
+Control volume and related notifications.
+
+Options:
+  -a                use alsa-utils instead of pulseaudio-utils for volume control
+  -c <card>         card number to control (amixer only)
+  -d <amount>       decrease volume
+  -e <expires>      expiration time of notifications, in milliseconds
+  -i <amount>       increase volume
+  -m                toggle mute
+  -n                show notifications
+  -p                show text volume progress bar
+  -s <sink_name>    symbolic name of sink (pulseaudio only)
+  -t <process_name> name of status line process. must be used with -u
+  -u <signal>       update status line using signal. must be used with -t
+  -v <value>        set volume
+  -y                use dunstify instead of notify-send
+  -h                display this help and exit
+" 1>&2
+    exit 1
+}
+###########################################################
+
+opt_decrease_volume=false
+opt_increase_volume=false
+opt_mute_volume=false
+opt_notification=false
+opt_set_volume=false
+opt_show_volume_progress=false
+opt_use_amixer=false
+opt_use_dunstify=false
+card=""
+signal=""
+sink=""
+statusline=""
+volume=5
+expires="1500"
+
+while getopts ":ac:d:e:hi:mnps:t:u:v:y" o; do
+    case "$o" in
+        a)
+            opt_use_amixer=true
+            ;;
+        c)
+            card="${OPTARG}"
+            ;;
+        d)
+            opt_decrease_volume=true
+            volume="${OPTARG}"
+            ;;
+        e)
+            expires="${OPTARG}"
+            ;;
+        i)
+            opt_increase_volume=true
+            volume="${OPTARG}"
+            ;;
+        m)
+            opt_mute_volume=true
+            ;;
+        n)
+            opt_notification=true
+            ;;
+        p)
+            opt_show_volume_progress=true
+            ;;
+        s)
+            sink="${OPTARG}"
+            ;;
+        t)
+            statusline="${OPTARG}"
+            ;;
+        u)
+            signal="${OPTARG}"
+            ;;
+        v)
+            opt_set_volume=true
+            volume="${OPTARG}"
+            ;;
+        y)
+            opt_use_dunstify=true
+            ;;
+        h | *)
+            usage
+            ;;
+    esac
+done
+shift $((OPTIND-1)) # Shift off options and optional --
+
+if ! $opt_use_amixer; then
+    if [ -z $sink ]; then
+        sink="$(get_default_sink_name)"
+    fi
+fi
+
+if ${opt_increase_volume}; then
+    raise_volume $volume
+fi
+
+if ${opt_decrease_volume}; then
+    lower_volume $volume
+fi
+
+if ${opt_set_volume}; then
+    set_volume $volume
+fi
+
+if ${opt_mute_volume}; then
+    toggle_mute $sink
+fi
+
+# The options below this line must be last
+if ${opt_notification}; then
+    if is_muted; then
+        notify_muted
+    else
+        notify_volume
+    fi
+fi
+
+if [ -n "${signal}" ]; then
+    if [ -z "${statusline}" ]; then
+        usage
+    fi
+    update_statusline "${signal}" "${statusline}"
+else
+    if [ -n "${statusline}" ]; then
+        usage
+    fi
+fi

BIN
i3/.config/i3/i3-volume/volume-notifications.png